#!/bin/sh
#------------------------------------------------
# IPIP tunnel config scipt on gateway side
#
# By Yu Cai (ycai@uccs.edu) at UCCS, June 2003
#------------------------------------------------

./cleanipip.sh

iptables -F
iptables -P INPUT ACCEPT
iptables -P FORWARD ACCEPT
echo "1">/proc/sys/net/ipv4/ip_forward

#define var
client_ip=192.168.0.1
proxy_ip=192.168.2.3
gw_ip=192.168.2.4
gw_gw=192.168.2.4
target_ip=192.168.4.2  #128.198.60.167
tunl=tunl2

#route between subnet
/sbin/iptables -A FORWARD -s 192.168.0.1 -d 192.168.4.2 -j ACCEPT
/sbin/iptables -A FORWARD -d 192.168.0.1 -s 192.168.4.2 -j ACCEPT
/sbin/iptables -A FORWARD -s 192.168.2.3 -d 192.168.4.2 -j ACCEPT
/sbin/iptables -A FORWARD -d 192.168.2.3 -s 192.168.4.2 -j ACCEPT
/sbin/iptables -A FORWARD -s 128.198.60.167 -d 192.168.0.1 -j ACCEPT
/sbin/iptables -A FORWARD -d 128.198.60.167 -s 192.168.0.1 -j ACCEPT

#config tunnel between gateway and proxy
ip tunnel del $tunl 
ip tunnel add $tunl mode ipip remote $proxy_ip dev eth1
ifconfig $tunl $gw_ip
ip link set $tunl up
ip route del $proxy_ip 
ip route add $proxy_ip via $gw_gw dev $tunl 

#route traffic between client and gateway through tunnel
ip route del $client_ip 
ip route add $client_ip via $gw_gw dev $tunl 

#route traffic between target and gateway through tunnel
gw_gw=192.168.4.4
ip route del $target_ip
ip route add $target_ip via $gw_gw dev eth0

#add-on
#config tunnel between gateway and target
tunl=tunl3
gw_ip=192.168.4.4
gw_gw=192.168.4.4
target_ip=192.168.4.2 #128.198.60.167
ip tunnel del $tunl
ip tunnel add $tunl mode ipip remote $target_ip dev eth0
ifconfig $tunl $gw_ip
ip link set $tunl up
ip route del $target_ip
ip route add $target_ip via $gw_gw dev $tunl

target_ip=128.198.60.167
ip route del $target_ip
ip route add $target_ip via $gw_gw dev $tunl
